/*-----------------------------------------------------------------------*/
/* (SPIł) MMCv3/SDv1/SDv2 Pʕ                              */
/*-----------------------------------------------------------------------*/
/*
/  쌠 (C) 2014, ChaN, s
/
/ * ̿ĳ͖ĳŕۏ؂͗L܂B
/ * gpɐ͗L܂BȂ̐ӔCɉĎgpAύXsA
/   pAc܂͏pipɂĔzz邱Ƃł܂B
/ *  ނ̍Ĕzz͏̒쌠ʒmێȂ΂Ȃ܂B
/
/-------------------------------------------------------------------------*/

#include <avr/io.h>
#include "diskio.h"


/* ߰Đ (Ոˑ) */
#define CS_LOW()	PORTB &= ~(1<<4)	/* CS = L */
#define	CS_HIGH()	PORTB |=  (1<<4)	/* CS = H */
#define MMC_CD		(!(PINB & 0x10))	/* ތoBL:^, :U, :^ */
#define MMC_WP		(PINB & 0x20)		/* ݕیBL:^, :U, :U */
#define	FCLK_SLOW()	SPCR0 = 0x52		/* ᑬۯݒ (F_CPU/64) */
#define	FCLK_FAST()	SPCR0 = 0x50		/* ۯݒ (F_CPU/2) */


/*--------------------------------------------------------------------------
   PʕI֐
---------------------------------------------------------------------------*/

/* MMC/SDCߗp` */
#define CMD0	(0)			/* GO_IDLE_STATE */
#define CMD1	(1)			/* SEND_OP_COND (MMC) */
#define	ACMD41	(0x80+41)	/* SEND_OP_COND (SDC) */
#define CMD8	(8)			/* SEND_IF_COND */
#define CMD9	(9)			/* SEND_CSD */
#define CMD10	(10)		/* SEND_CID */
#define CMD12	(12)		/* STOP_TRANSMISSION */
#define ACMD13	(0x80+13)	/* SD_STATUS (SDC) */
#define CMD16	(16)		/* SET_BLOCKLEN */
#define CMD17	(17)		/* READ_SINGLE_BLOCK */
#define CMD18	(18)		/* READ_MULTIPLE_BLOCK */
#define CMD23	(23)		/* SET_BLOCK_COUNT (MMC) */
#define	ACMD23	(0x80+23)	/* SET_WR_BLK_ERASE_COUNT (SDC) */
#define CMD24	(24)		/* WRITE_BLOCK */
#define CMD25	(25)		/* WRITE_MULTIPLE_BLOCK */
#define CMD32	(32)		/* ERASE_ER_BLK_START */
#define CMD33	(33)		/* ERASE_ER_BLK_END */
#define CMD38	(38)		/* ERASE */
#define CMD55	(55)		/* APP_CMD */
#define CMD58	(58)		/* READ_OCR */

static volatile
DSTATUS Stat = STA_NOINIT;	/* ި */

static volatile
BYTE Timer1, Timer2;	/* 100Hzv */

static
BYTE CardType;			/* ތ`׸ */


/*-----------------------------------------------------------------------*/
/* d͐ (Ոˑ)                                                   */
/*-----------------------------------------------------------------------*/
/* ړIΏۼтd͐̎󂯌xȂ́Å֐ōs  */
/* Ƃ͉ȂAchk_power͏1Ԃ܂B                            */

static void power_on (void)
{
	PORTB |= (1<<PORTB4);
	DDRB |= (1<<DDRB4) | (1<<DDRB5) | (1<<DDRB7);	/* MOSISCKóȂSĂ͂ɐݒ */
	SPCR0 = (1<<SPE0)|(1<<MSTR0);					/* SPIA呕uAfck/16ۯxɐݒ */
}

static void power_off (void)
{
	SPCR0 = 0;										/* SPI@\֎~ */
	DDRB &= ~((1<<DDRB4) | (1<<DDRB5) | (1<<DDRB7));
	PORTB &= ~(1<<PORTB4);
}


/*-----------------------------------------------------------------------*/
/* SPIoRMMCް𑗎M (Ոˑ)                                 */
/*-----------------------------------------------------------------------*/

/* ޲Č */
static BYTE xchg_spi (BYTE dat)
{
	SPDR0 = dat;
	while(!(SPSR0 & (1 << SPIF0)));
	return SPDR0;
}

/* ް򍂑M */
static void xmit_spi_multi (const BYTE *p, UINT cnt)
{
	do {
		SPDR0 = *p++;
		while(!(SPSR0 & (1 << SPIF0)));
		SPDR0 = *p++;
		while(!(SPSR0 & (1 << SPIF0)));
	} while (cnt -= 2);
}

/* ް򍂑M */
static void rcvr_spi_multi (BYTE *p, UINT cnt)
{
	do {
		SPDR0 = 0xFF;
		while(!(SPSR0 & (1 << SPIF0)));
		*p++ = SPDR0;
		SPDR0 = 0xFF;
		while(!(SPSR0 & (1 << SPIF0)));
		*p++ = SPDR0;
	} while (cnt -= 2);
}

/*-----------------------------------------------------------------------*/
/* ޏҋ@                                                        */
/*-----------------------------------------------------------------------*/

static int wait_ready (UINT wt)
{
	BYTE d;

	Timer2 = wt / 10;
	do
		d = xchg_spi(0xFF);
	while (d != 0xFF && Timer2);

	return (d == 0xFF) ? 1 : 0;
}


/*-----------------------------------------------------------------------*/
/* ޑISPI޽J                                              */
/*-----------------------------------------------------------------------*/

static void deselect (void)
{
	CS_HIGH();		/* /CSn=Highݒ */
	xchg_spi(0xFF);	/* Uۯ(]uSPIɑ΂DOHi-Zɋ) */
}


/*-----------------------------------------------------------------------*/
/* ޑIƏҋ@                                                  */
/*-----------------------------------------------------------------------*/

static int select (void)	/* 1:, 0:Ԓ */
{
	CS_LOW();						/* CSn=Lowݒ */
	xchg_spi(0xFF);					/* Uۯ(DO) */
	if (wait_ready(500)) return 1;	/* ޏҋ@ */

	deselect();
	return 0;	/* Ԓ */
}


/*-----------------------------------------------------------------------*/
/* MMCް ߹ĎM                                                 */
/*-----------------------------------------------------------------------*/

static
int rcvr_datablock (
	BYTE *buff,			/* Mްi[pްɏՕ */
	UINT btr			/* ޲Čv(4{łȂ΂Ȃ܂B) */
)
{
	BYTE token;

	Timer1 = 20;
	do {							/* 200msް ߹đҋ@ */
		token = xchg_spi(0xFF);
	} while ((token == 0xFF) && Timer1);
	if (token != 0xFE) return 0;	/* ްʕ[ŁAُԂ */

	rcvr_spi_multi(buff, btr);		/* ްɏՕɎM */
	xchg_spi(0xFF);					/* CRCj */
	xchg_spi(0xFF);

	return 1;						/* Ԃ */
}


/*-----------------------------------------------------------------------*/
/* MMCް ߹Ă𑗂                                                 */
/*-----------------------------------------------------------------------*/

#if	_USE_WRITE
static
int xmit_datablock (
	const BYTE *buff,	/* M512޲Ăް */
	BYTE token			/* ް/~̒ʕ[ */
)
{
	BYTE resp;

	if (!wait_ready(500)) return 0;

	xchg_spi(token);					/* ްʕ[M */
	if (token != 0xFD) {				/* ްʕ[? */
		xmit_spi_multi(buff, 512);		/* MMCް򑗐M */
		xchg_spi(0xFF);					/* CRC(U) */
		xchg_spi(0xFF);
		resp = xchg_spi(0xFF);			/* ްM */
		if ((resp & 0x1F) != 0x05)		/* ŁAُԂ */
			return 0;
	}

	return 1;
}
#endif


/*-----------------------------------------------------------------------*/
/* MMCɖ߹Ă𑗂                                                  */
/*-----------------------------------------------------------------------*/

static
BYTE send_cmd (		/* R1ԂB(ޯ7=1:Ms) */
	BYTE cmd,		/* ߎwW */
	DWORD arg		/*  */
)
{
	BYTE n, res;

	if (cmd & 0x80) {	/* ACMD<n>CMD55-CMD<n>̖ߎ菇 */
		cmd &= 0x7F;
		res = send_cmd(CMD55, 0);
		if (res > 1) return res;
	}

	/* ނIĕǂݍݒ~ďҋ@ */
	if (cmd != CMD12) {
		deselect();
		if (!select()) return 0xFF;
	}

	/* ߹đo */
	xchg_spi(0x40 | cmd);				/* Jn+ߎwW */
	xchg_spi((BYTE)(arg >> 24));		/* [31`24] */
	xchg_spi((BYTE)(arg >> 16));		/* [23`16] */
	xchg_spi((BYTE)(arg >> 8));			/* [15`8] */
	xchg_spi((BYTE)arg);				/* [7`0] */
	n = 0x01;							/* UCRC+~ */
	if (cmd == CMD0) n = 0x95;			/* CMD0(0)pLCRC+~ */
	if (cmd == CMD8) n = 0x87;			/* CMD8(0x1AA)pLCRC+~ */
	xchg_spi(n);

	/* ߉M */
	if (cmd == CMD12) xchg_spi(0xFF);		/* ~ǂݎ莞Ɍ޲Ĕ΂ */
	n = 10;									/* 10̎s̎ԐŗLҋ@ */
	do
		res = xchg_spi(0xFF);
	while ((res & 0x80) && --n);

	return res;			/* lԂ */
}


/*--------------------------------------------------------------------------
   I֐
---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/* ި ײޏ                                                    */
/*-----------------------------------------------------------------------*/

DSTATUS disk_initialize (
	BYTE pdrv		/* ײޔԍ (0) */
)
{
	BYTE n, cmd, ty, ocr[4];


	if (pdrv) return STA_NOINIT;		/* Pײނ̂ݎx */
	power_off();						/* ނؾĂ邽߂ɿēd͂OFF */
	if (Stat & STA_NODISK) return Stat;	/* ĂɶނȂ */
	power_on();							/* ēd͂ON */
	FCLK_SLOW();
	for (n = 10; n; n--) xchg_spi(0xFF);	/* 80^ۯ */

	ty = 0;
	if (send_cmd(CMD0, 0) == 1) {			/* ُԂֈڍs */
		Timer1 = 100;						/* 1000ms̐ԏ */
		if (send_cmd(CMD8, 0x1AA) == 1) {	/* SDv2? */
			for (n = 0; n < 4; n++) ocr[n] = xchg_spi(0xFF);	/* R7̌Ԃl擾 */
			if (ocr[2] == 0x01 && ocr[3] == 0xAA) {				/* ނ2.7`3.6VVdd͈͂œ */
				while (Timer1 && send_cmd(ACMD41, 1UL << 30));	/* ُԂ̂܂܂őҋ@(HCSޯĂACMD41) */
				if (Timer1 && send_cmd(CMD58, 0) == 0) {		/* OCRCCSޯČ */
					for (n = 0; n < 4; n++) ocr[n] = xchg_spi(0xFF);
					ty = (ocr[0] & 0x40) ? CT_SD2 | CT_BLOCK : CT_SD2;	/* SDv2 */
				}
			}
		} else {							/* SDv1܂MMCv3 */
			if (send_cmd(ACMD41, 0) <= 1) 	{
				ty = CT_SD1; cmd = ACMD41;	/* SDv1 */
			} else {
				ty = CT_MMC; cmd = CMD1;	/* MMCv3 */
			}
			while (Timer1 && send_cmd(cmd, 0));			/* ُԂ̂܂ܑҋ@ */
			if (!Timer1 || send_cmd(CMD16, 512) != 0)	/* R/W򒷂512ɐݒ */
				ty = 0;
		}
	}
	CardType = ty;
	deselect();

	if (ty) {			/*  */
		Stat &= ~STA_NOINIT;		/* STA_NOINIT */
		FCLK_FAST();
	} else {			/* s */
		power_off();
	}

	return Stat;
}


/*-----------------------------------------------------------------------*/
/* ިԎ擾                                                         */
/*-----------------------------------------------------------------------*/

DSTATUS disk_status (
	BYTE pdrv		/* ײޔԍ (0) */
)
{
	if (pdrv) return STA_NOINIT;	/* Pײނ̂ݎx */
	return Stat;
}


/*-----------------------------------------------------------------------*/
/* ǂݍ                                                           */
/*-----------------------------------------------------------------------*/

DRESULT disk_read (
	BYTE pdrv,			/* ײޔԍ (0) */
	BYTE *buff,			/* ǂްi[ްɏՕւ̈ʒuwq */
	DWORD sector,		/* Jnԍ(LBA) */
	UINT count			/* v(1`128) */
)
{
	BYTE cmd;

	if (pdrv || !count) return RES_PARERR;
	if (Stat & STA_NOINIT) return RES_NOTRDY;

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* KvȂA޲ ڽɕϊ */

	cmd = count > 1 ? CMD18 : CMD17;			/*  READ_MULTIPLE_BLOCK : READ_SINGLE_BLOCK */
	if (send_cmd(cmd, sector) == 0) {
		do {
			if (!rcvr_datablock(buff, 512)) break;
			buff += 512;
		} while (--count);
		if (cmd == CMD18) send_cmd(CMD12, 0);	/* STOP_TRANSMISSION */
	}
	deselect();

	return count ? RES_ERROR : RES_OK;
}


/*-----------------------------------------------------------------------*/
/*                                                            */
/*-----------------------------------------------------------------------*/

#if _USE_WRITE
DRESULT disk_write (
	BYTE pdrv,			/* ײޔԍ (0) */
	const BYTE *buff,	/* ްւ̈ʒuwq */
	DWORD sector,		/* Jnԍ(LBA) */
	UINT count			/* v(1`128) */
)
{
	if (pdrv || !count) return RES_PARERR;
	if (Stat & STA_NOINIT) return RES_NOTRDY;
	if (Stat & STA_PROTECT) return RES_WRPRT;

	if (!(CardType & CT_BLOCK)) sector *= 512;	/* KvȂA޲ ڽɕϊ */

	if (count == 1) {	/* P򏑂 */
		if ((send_cmd(CMD24, sector) == 0)	/* WRITE_BLOCK */
			&& xmit_datablock(buff, 0xFE))
			count = 0;
	}
	else {				/* 򏑂 */
		if (CardType & CT_SDC) send_cmd(ACMD23, count);
		if (send_cmd(CMD25, sector) == 0) {	/* WRITE_MULTIPLE_BLOCK */
			do {
				if (!xmit_datablock(buff, 0xFC)) break;
				buff += 512;
			} while (--count);
			if (!xmit_datablock(0, 0xFD))	/* STOP_TRAN token */
				count = 1;
		}
	}
	deselect();

	return count ? RES_ERROR : RES_OK;
}
#endif


/*-----------------------------------------------------------------------*/
/* ̑̊֐                                                          */
/*-----------------------------------------------------------------------*/

#if _USE_IOCTL
DRESULT disk_ioctl (
	BYTE pdrv,		/* ײޔԍ (0) */
	BYTE cmd,		/* 䕄 */
	void *buff		/* ްMpɏՕ */
)
{
	DRESULT res;
	BYTE n, csd[16], *ptr = buff;
	DWORD csize;

	if (pdrv) return RES_PARERR;

	res = RES_ERROR;

	if (Stat & STA_NOINIT) return RES_NOTRDY;

	switch (cmd) {
	case CTRL_SYNC :		/* ۗݏȂƊmɂĂB苎Ă͂܂BȂΏꂽXVꂽ܂܂ɂȂ蓾܂B */
		if (select()) res = RES_OK;
		break;

	case GET_SECTOR_COUNT :	/* ި̾擾(DWORD) */
		if ((send_cmd(CMD9, 0) == 0) && rcvr_datablock(csd, 16)) {
			if ((csd[0] >> 6) == 1) {	/* SDC ver 2.00 */
				csize = csd[9] + ((WORD)csd[8] << 8) + ((DWORD)(csd[7] & 63) << 16) + 1;
				*(DWORD*)buff = csize << 10;
			} else {					/* SDC ver 1.XX܂MMC*/
				n = (csd[5] & 15) + ((csd[10] & 128) >> 7) + ((csd[9] & 3) << 1) + 2;
				csize = (csd[8] >> 6) + ((WORD)csd[7] << 2) + ((WORD)(csd[6] & 3) << 10) + 1;
				*(DWORD*)buff = csize << (n - 9);
			}
			res = RES_OK;
		}
		break;

	case GET_BLOCK_SIZE :	/* Pʂł̏eʂ擾(DWORD) */
		if (CardType & CT_SD2) {	/* SDv2? */
			if (send_cmd(ACMD13, 0) == 0) {	/* SDԎ擾 */
				xchg_spi(0xFF);
				if (rcvr_datablock(csd, 16)) {				/* ̕ǂݍ */
					for (n = 64 - 16; n; n--) xchg_spi(0xFF);	/* ް菜 */
					*(DWORD*)buff = 16UL << (csd[10] >> 4);
					res = RES_OK;
				}
			}
		} else {					/* SDv1܂MMCv3 */
			if ((send_cmd(CMD9, 0) == 0) && rcvr_datablock(csd, 16)) {	/* CSDǂݍ */
				if (CardType & CT_SD1) {	/* SDv1 */
					*(DWORD*)buff = (((csd[10] & 63) << 1) + ((WORD)(csd[11] & 128) >> 7) + 1) << ((csd[13] >> 6) - 1);
				} else {					/* MMCv3 */
					*(DWORD*)buff = ((WORD)((csd[10] & 124) >> 2) + 1) * (((csd[11] & 3) << 3) + ((csd[11] & 224) >> 5) + 1);
				}
				res = RES_OK;
			}
		}
		break;

	/* ȉ̖߂FatFsPʕɂČĎgp܂B */

	case MMC_GET_TYPE :		/* ތ`׸ގ擾(1޲) */
		*ptr = CardType;
		res = RES_OK;
		break;

	case MMC_GET_CSD :		/* ްƂCSDM(16޲) */
		if (send_cmd(CMD9, 0) == 0		/* READ_CSD */
			&& rcvr_datablock(ptr, 16))
			res = RES_OK;
		break;

	case MMC_GET_CID :		/* ްƂCIDM(16޲) */
		if (send_cmd(CMD10, 0) == 0		/* READ_CID */
			&& rcvr_datablock(ptr, 16))
			res = RES_OK;
		break;

	case MMC_GET_OCR :		/* R3ƂOCRM(4޲) */
		if (send_cmd(CMD58, 0) == 0) {	/* READ_OCR */
			for (n = 4; n; n--) *ptr++ = xchg_spi(0xFF);
			res = RES_OK;
		}
		break;

	case MMC_GET_SDSTAT :	/* ްƂSDԂM(64޲) */
		if (send_cmd(ACMD13, 0) == 0) {	/* SD_STATUS */
			xchg_spi(0xFF);
			if (rcvr_datablock(ptr, 64))
				res = RES_OK;
		}
		break;

	case CTRL_POWER_OFF :	/* dOFF */
		power_off();
		Stat |= STA_NOINIT;
		res = RES_OK;
		break;

	default:
		res = RES_PARERR;
	}

	deselect();

	return res;
}
#endif


/*-----------------------------------------------------------------------*/
/* ޲v튄荞ݎ葱                                            */
/*-----------------------------------------------------------------------*/
/* ̊֐100msɌĂ΂Ȃ΂Ȃ܂B                         */

void disk_timerproc (void)
{
	BYTE n, s;

	n = Timer1;				/* 100Hzv */
	if (n) Timer1 = --n;
	n = Timer2;
	if (n) Timer2 = --n;

	s = Stat;

	if (MMC_WP)				/* ݕی */
		s |= STA_PROTECT;
	else					/* ݋ */
		s &= ~STA_PROTECT;

	if (MMC_CD)				/* ޑ} */
		s &= ~STA_NODISK;
	else					/* ċ */
		s |= (STA_NODISK | STA_NOINIT);

	Stat = s;				/* MMCԍXV */
}
