/**
 * \file
 *
 * \brief ̨ ײAPIͯ ̧
 *
 * 쌠 (c) 2011-2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef GFX_MONO_H
#define GFX_MONO_H

#include <stdint.h>

#include <avr/io.h>
#include "progmem.h"
#ifdef CONFIG_HAVE_HUGEMEM
# include "hugemem.h"
#endif

/**
 * \defgroup gfx_mono Monochrome graphical display system
 *
 * Q \ref gfx_mono_quickstart.
 *
 * ײ؂̨͔\Ÿ̨`߂̲̪񋟂܂B
 *
 * ̨ ײނ͈ȉ琬܂B
 * - \ײ ̪ (gfx_mono.h)
 * - W̨`{vf (gfx_mono_generic.h)
 * - \L (ex. gfx_mono_c12832_a1z.h)
 *
 * W`{vf͐A`A~̂悤Ȑ}`{vf`߂̊֐ײ؂
 * B͊{vf`悷邽߂̕\ײނɂĎꂽ̊֐gp
 * ܂B̊֐͕̎\ײނɂĔCӂŎgp꓾܂A\
 * ʰ޳{vf̂ǂ葬ȂA\ײނ͂𒼐ڎ
 * 邱Ƃł܂B
 *
 * \ײނ͸̨\ɑ΂̪񋟂܂B͕\ʰ
 * Ƃ̒ʒʐMA\ł߸ٔzuA~`̂悤Ȋ{vf`
 * ܂B\ײގɈˑāĄ{vf`͕\ײނꎩg
 * ނW̨{vf`ɂď邩܂B
 *
 * \note ײؓ̊֐͊荞݂ɈSł͂܂B
 * @{
 */

typedef uint8_t gfx_mono_color_t;
typedef uint8_t gfx_coord_t;

/** ߸ّ */
enum gfx_mono_color {
	GFX_PIXEL_CLR = 0,						/** ߸ق͉܂B */
	GFX_PIXEL_SET = 1,						/** ߸ق͉ʂŐݒ(OR)܂B */
	GFX_PIXEL_XOR = 2,						/** ߸قXOR܂B */
};

/** ޯϯߌ` */
enum gfx_mono_bitmap_type {
	GFX_MONO_BITMAP_RAM,					/** SRAMɊi[ޯϯ */
	GFX_MONO_BITMAP_PROGMEM					/** ۸ѓɊi[ޯϯ */
};

/* 炪ޯϯ߂ƐF̗񋓂Ɏgp邽߁A擪Ɉړ邱Ƃł܂B */
#ifdef USE_SDL
# include "gfx_mono_sdl.h"
#elif defined(GFX_MONO_C12832_A1Z)
# include "gfx_mono_c12832_a1z.h"
#elif defined(GFX_MONO_UG_2832HSWEG04)
# include "gfx_mono_ug_2832hsweg04.h"
#else
# include "gfx_mono_null.h"					/* ɂNULLײ */
#endif
#include "gfx_mono_generic.h"

/** \name ~̐`` */
/** @{ */

#define GFX_OCTANT0		(1 << 0)			/** ~8~0`pޯĎՕ */
#define GFX_OCTANT1		(1 << 1)			/** ~8~1`pޯĎՕ */
#define GFX_OCTANT2		(1 << 2)			/** ~8~2`pޯĎՕ */
#define GFX_OCTANT3		(1 << 3)			/** ~8~3`pޯĎՕ */
#define GFX_OCTANT4		(1 << 4)			/** ~8~4`pޯĎՕ */
#define GFX_OCTANT5		(1 << 5)			/** ~8~5`pޯĎՕ */
#define GFX_OCTANT6		(1 << 6)			/** ~8~6`pޯĎՕ */
#define GFX_OCTANT7		(1 << 7)			/** ~8~7`pޯĎՕ */

#define GFX_QUADRANT0	(GFX_OCTANT0 | GFX_OCTANT1)	/** ~4~0`pޯĎՕ */
#define GFX_QUADRANT1	(GFX_OCTANT2 | GFX_OCTANT3)	/** ~4~1`pޯĎՕ */
#define GFX_QUADRANT2	(GFX_OCTANT4 | GFX_OCTANT5)	/** ~4~2`pޯĎՕ */
#define GFX_QUADRANT3	(GFX_OCTANT6 | GFX_OCTANT7)	/** ~4~3`pޯĎՕ */

#define GFX_LEFTHALF	(GFX_QUADRANT3 | GFX_QUADRANT0)	/** ~̍`pޯĎՕ */
#define GFX_TOPHALF		(GFX_QUADRANT0 | GFX_QUADRANT1)	/** ~̏㔼`pޯĎՕ */
#define GFX_RIGHTHALF	(GFX_QUADRANT1 | GFX_QUADRANT2)	/** ~̉E`pޯĎՕ */
#define GFX_BOTTOMHALF	(GFX_QUADRANT2 | GFX_QUADRANT3)	/** ~̉`pޯĎՕ */

#define GFX_WHOLE		0xFF				/** ~S̕`pޯĎՕ */
/** @} */

/** \name {vf̨` */
/** @{ */

/**
 * \def gfx_mono_draw_horizontal_line(x, y, length, color)
 * \brief 1߸ٕŐ`
 *
 * \param x			[߸قXW
 * \param y			YW
 * \param length	߸قł̒
 * \param color		߸ّ
 */

/**
 * \def gfx_mono_draw_vertical_line(x, y, length, color)
 * \brief 1߸ٕŐ`
 *
 * \param x			XW
 * \param y			[߸قYW
 * \param length	߸قł̒
 * \param color		߸ّ
 */

/**
 * \def gfx_mono_draw_line(x1, y1, x2, y2, color)
 * \brief Cӂ2_Ԃɐ`
 *
 * \param x1		JnXW
 * \param y1		JnYW
 * \param x2		IXW
 * \param y2		IYW
 * \param color		߸ّ
 */

/**
 * \def gfx_mono_draw_rect(x, y, width, height, color)
 * \brief `̊O``
 *
 * \param x			XW
 * \param y			㑤YW
 * \param width		`̕
 * \param height	`̍
 * \param color		߸ّ
 */

/**
 * \def gfx_mono_draw_filled_rect(x, y, width, height, color)
 * \brief hׂ`̕`
 *
 * \param x			XW
 * \param y			㑤YW
 * \param width		`̕
 * \param height	`̍
 * \param color		߸ّ
 */

/**
 * \def gfx_mono_draw_circle(x, y, radius, color, octant_mask)
 * \brief ~܂͌ʂ̊O``
 *
 * a(radius)͉~ɑ΂钆S̋ŁA~̑Iȕ܂͍(radius
 * ~2+1)ɂȂ邱ƂӖ܂B
 *
 * octant_maskҰ͉~̂ǂ8~`悷邩߂ޯĎՕłB
 * GFX_OCTANTn, GFX_QUADRANTn, GFX_xHALF, GFX_WHOLE萔ƕKvȂ΂
 * ORĎgpĂBa=0͒P߸ق^܂B
 *
 * \param x				SXW
 * \param y				SYW
 * \param radius		~߸قł̔a
 * \param color			߸ّ
 * \param octant_mask	ǂ8~`悷邩ޯĎՕ
 */

/**
 * \def gfx_mono_draw_filled_circle(x, y, radius, color, quadrant_mask)
 * \brief hׂꂽ~܂͐`̕`
 *
 * a(radius)͉~ɑ΂钆S̋ŁA~̑Iȕ܂͍(radius
 * ~2+1)ɂȂ邱ƂӖ܂B
 *
 * quadrant_maskҰ͉~̂ǂ4~`悷邩߂ޯĎՕłB
 * GFX_QUADRANTn, GFX_xHALF, GFX_WHOLE萔ƕKvȂ΂ORĎgp
 * Ba=0͒P߸ق^܂B
 *
 * \note ̊֐4~xAgfx_draw_circle()8~x܂B
 *		 ͓hԂ~`ł̐\P܂B
 *
 * \param x				SXW
 * \param y				SYW
 * \param radius		߸قł̉~a
 * \param color			߸ّ
 * \param quadrant_mask	ǂ4~`悷邩ޯĎՕ
 */

/** @} */
/** @} */

/**
 * \page gfx_mono_quickstart ̨ ޽pJn̎
 *
 * ͓gpɑ΂Ăǂ`Ԑݒ肵Ďgp̂̒iKIȎwA
 * \ref gfx_mono "̨ ޽"p̑Jn̎łB
 *
 * \section gfx_mono_quickstart_basic ̨ ޽̊{IȎgp@
 * ̎gp̨͔ ޽Ă̌ɍWX=10,Y=10`X=20,Y=20
 * ŉʏɍ`悷łB
 *
 * \section gfx_mono_basic_usage iKIgp@
 * \subsection gfx_mono_basic_usage_code Ằ
 * ႦΉpÇقmain֐ɒǉĂB
 * \code
	board_init();
	sysclk_init();
	gfx_mono_init();
	gfx_mono_draw_line(10, 10, 20, 20, GFX_PIXEL_SET);
\endcode
 *
 * \subsection gfx_mono_basic_usage Ƃ̗
 * -# o͏:
 *  - \code board_init(); \endcode
 * -# ۯ:
 *  - \code sysclk_init(); \endcode
 * -# ̨ ޽
 *  - \code gfx_mono_init(); \endcode
 *  - \note ͒ʕ\ײނɑ΂鏉֐Ă΂AwʂY
 *			ɂ邽߂ɉʂ܂B
 * -# 10,10`20,20֐`:
 * -  \code gfx_mono_draw_line(10, 10, 20, 20, GFX_PIXEL_SET); \endcode
 * -  \note ͐ŕ\߸قݒ肷̂GFX_PIXEL_SETgp܂B
 *			̔CӑI\ref gfx_mono_colorœ܂B
 */

#endif /* GFX_MONO_H */
